c convert binary to ascii surface file
c also writes a dummy pdb file that can be examined with rasmol etc

      parameter(nvmax=35000)
      parameter(ntmax=100000)
      integer*4 inin(3,ntmax)
      real*4 posn(3,nvmax),norm(3,nvmax)
      real maxcrd(3),mincrd(3),avcrd(3)
      character*80 line
      character*6 atom
      character*4 atnm,resnm
      character*256 srfin,srfout,pdbout

      write(*,*) 'number of surface vertices?'
      read(*,*)nv
      write(*,*) 'number of surface triangles?'
      read(*,*)nt
      write(*,*) 'file name of input binary surface file (in '' '')?'
      read(*,*,err=922)srfin
      write(*,*) 'file name of output ascii surface file (in '' '')?'
      read(*,*,err=922)srfout
      write(*,*) 'file name of output pdb file of surface (in '' '')?'
      read(*,*,err=922)pdbout
      if(nv.gt.nvmax)then
         write(*,*)'sorry, more vertices than allowed' 
         write(*,*)'(recompile, increasing parameter nvmax)'
         stop 
      endif
      if(nt.gt.ntmax)then
         write(*,*)'sorry, more triangles than allowed'
         write(*,*)'(recompile, increasing parameter nvmax)'
         stop 
      endif
      write(*,*) 'thank you very much...'
      write(*,*) 


      open(unit=13,file=srfin, form='unformatted')
      open(unit=14,file=srfout)
      open(unit=15,file=pdbout)
      atom='ATOM'
      atnm='CGR'
      resnm='GSF '
      do k=1,3
         avcrd(k)=0
         maxcrd(k)=-1999
         mincrd(k)=1999
      enddo

      do i=1,5
         read(13)line
         write(14,*)  line 
      enddo

c vertices
      write(*,*) 'vertices'
      read(13) ((posn(k,j),k=1,3),j=1,nv)
      do j=1,nv
         write(14,*)  j,(posn(k,j),k=1,3)
         write(15,900)  atom,j,atnm,resnm,j,(posn(k,j),k=1,3),0.0,0.0
         do k=1,3
            avcrd(k)=avcrd(k)+posn(k,j)
            if(posn(k,j).gt.maxcrd(k))maxcrd(k)=posn(k,j)
            if(posn(k,j).lt.mincrd(k))mincrd(k)=posn(k,j)
         enddo
      enddo
      do k=1,3
         avcrd(k)=avcrd(k)/nv
      enddo

c accessible surface points 
c (use norm array as want to keep the vertices safe in posn)
      write(*,*) 'accessible surface points'
      read(13) ((norm(k,j),k=1,3),j=1,nv)
      do j=1,nv
         write(14,*)  j,(norm(k,j),k=1,3)
      enddo
c      pause

c normals
      atnm='CGN'
      write(*,*) 'normals'
      read(13) ((norm(k,j),k=1,3),j=1,nv)
      do j=1,nv
         write(14,*)  j,(norm(k,j),k=1,3)
         write(15,900)  
     &     atom,j,atnm,resnm,j,(posn(k,j)+norm(k,j),k=1,3),0.0,0.0
      enddo
c      pause

c triangles
      write(*,*) 'triangles'
      read(13) ((inin(k,j),k=1,3),j=1,nt)
      do j=1,nt
         write(14,*)  j,(inin(k,j),k=1,3)
      enddo

      write(*,*)
      write(*,*)'check centering:'
      write(*,*)'centre of mass of surface:',(avcrd(k),k=1,3)
      write(*,*)'minimum and maximum x coordinates:',mincrd(1),maxcrd(1)
      write(*,*)'minimum and maximum y coordinates:',mincrd(2),maxcrd(2)
      write(*,*)'minimum and maximum z coordinates:',mincrd(3),maxcrd(3)
      
      close(15)
 900  format(a6,i5,2x,a4,a4,i5,4x,3(1x,f7.3),2(1x,f5.2))
      stop
c     recover from file input error
 922  write(*,*)'error in input of file name - did you remember'
      write(*,*)' to put it in inverted commas?'

      end

